typedef struct TextLine {
	char *text;
	int allocable; // Last allocable position (if used, must be '\0')
	int length; // Position of the first non-writable character ('\n' or '\0')
	struct TextLine *next;
	struct TextLine *last;
} TextLine;

typedef struct TextBuffer {
	struct TextLine *lines; // Start of theline list
	struct TextLine *cursorline; // Line the cursor is in
	int cursorcolumn; // Column the cursor is in
} TextBuffer;

struct TextLine *newTextLine();
int lineExtend(struct TextLine *line);
int lineAddChar(struct TextLine *line, char newchar, int position);
int lineDelChar(struct TextLine *line, int position);
struct TextBuffer *newTextBuffer();
void destroyBuffer(struct TextBuffer *buffer);
int bufferNewLine(struct TextBuffer *buffer);
int bufferAddChar(struct TextBuffer *buffer, char newchar);
int bufferDelChar(struct TextBuffer *buffer);
int moveCursorRight(struct TextBuffer *buffer);
int moveCursorUp(struct TextBuffer *buffer);
int moveCursorLeft(struct TextBuffer *buffer);
int moveCursorDown(struct TextBuffer *buffer);
