#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include "buffer.h"
#include "input.h"

void printBuffer(struct TextBuffer *buffer){
	/* Prints all the lines from a TextBuffer into the DebugScreen, the colors 
	 * of the position occupied by the cursor is reversed*/
	struct TextLine *line;
	int xpos,ypos,xpos2,ypos2;
	char blank = ' ';
	line = buffer->lines;
	pspDebugScreenSetXY(0,1);
	while (line){
		if (line == buffer->cursorline){ // If we are in the line containing the cursor (what an ugly bunch of code)
			if (buffer->cursorcolumn > 0) pspDebugScreenPrintData(line->text, (buffer->cursorcolumn) * sizeof(char)); // We print the line until the cursor position
			xpos = pspDebugScreenGetX(); // Memorize the position (so we left to the psp the task of managing the screen size)
			ypos = pspDebugScreenGetY();
			pspDebugScreenPrintf(line->text + buffer->cursorcolumn); // We print the rest of the line
			xpos2 = pspDebugScreenGetX(); // And memorize the position for later (actually, only Y position is needed, X is always 0)
			ypos2 = pspDebugScreenGetY();
			pspDebugScreenSetXY(xpos,ypos); // This 8 lines for printing the cursor
			pspDebugScreenSetTextColor(0xffffffff);
			pspDebugScreenSetBackColor(0x00000000);
			if (line->length == buffer->cursorcolumn) pspDebugScreenPrintData(&blank, sizeof(char)); // Better not to print messy characters like '\0' or '\n'
			else pspDebugScreenPrintData(line->text + buffer->cursorcolumn, sizeof(char));
			pspDebugScreenSetTextColor(0x00000000);
			pspDebugScreenSetBackColor(0xffffffff);
			pspDebugScreenSetXY(xpos2,ypos2); // And return to the end of the cursor line
		}
		else pspDebugScreenPrintf("%s",line->text);
		line = line->next;
	}
}

void printCommandBuffer(struct TextBuffer *buffer){
	/* Prints the first line of the commandbuffer at the end of the
	 * DebugScreen */
	pspDebugScreenSetXY(0,32);
	pspDebugScreenPrintf("%s",buffer->lines->text);
}

void printWriteHelp(SceCtrlData pad, int x, int y, int charset){
	/* This functions prints the writing help on the coordinates provided,
	 * this is not well coded, some constants need to be defined and all
	 * the redundant code from input.c eliminated. */
	int c,offset = charset*75;
	if (pad.Buttons & PSP_CTRL_LTRIGGER) offset = offset + 19;
	if (pad.Buttons & PSP_CTRL_RTRIGGER) offset = offset + 38;
	c = getChar(pad,charset);
	if (x < 2) x = 0;
	pspDebugScreenSetTextColor(0xff00ff00);
	pspDebugScreenSetXY(x-2,y+2);
	pspDebugScreenPrintf("%c %c %c\n",getCode(offset+4),getCode(offset+3),getCode(offset+2));
	pspDebugScreenSetXY(x-2,y+3);
	pspDebugScreenPrintf("%c ",getCode(offset+5));
	if (c > 0){
		pspDebugScreenSetTextColor(0xff000000);
		pspDebugScreenPrintf("%c",c);
		pspDebugScreenSetTextColor(0xff00ff00);
	}
	else pspDebugScreenPrintf(" ");
	pspDebugScreenPrintf(" %c\n",getCode(offset+1));
	pspDebugScreenSetXY(x-2,y+4);
	pspDebugScreenPrintf("%c %c %c\n",getCode(offset+6),getCode(offset+7),getCode(offset+8));
	pspDebugScreenSetTextColor(0xff000000);
}
