#include <pspiofilemgr.h>
#include <pspdebug.h>
#include "buffer.h"

struct TextBuffer *loadFile(char *filename){
	/* Loads the file <filename> into a new TextBuffer, the path must be
	 * absolute, so probably would be like "ms0:/psp/game/pspted/filename"
	 * or something like that */
	SceUID fd;
	struct TextBuffer *buffer;
	char c;
	
	buffer = newTextBuffer();
	fd = sceIoOpen(filename,PSP_O_RDONLY,0777);
	if (fd < 0){
		pspDebugScreenPrintf("Error when opening file %s\n",filename);
	}
	else {
		while(sceIoRead(fd,&c,sizeof(char))) {
			bufferAddChar(buffer,c);
			if (c == '\n') bufferNewLine(buffer);
		}
	}
	sceIoClose(fd);
	return buffer;
}

void saveFile(struct TextBuffer *buffer,char *filename){
	/* Saves the TextBuffer provided in a file, the path must be absolute*/
	SceUID fd;
	struct TextLine *line;
	
	line = buffer->lines;
	fd = sceIoOpen(filename,PSP_O_WRONLY|PSP_O_CREAT,0777);
	if (fd < 0){
		pspDebugScreenPrintf("Error when opening file %s\n",filename);
	}
	else{
		while(line){
			sceIoWrite(fd,line->text,(line->length + 1)*sizeof(char));
			line = line->next;
		}
	}
	sceIoClose(fd);
}
